﻿using System;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;

namespace WCFTransactions
{
	public class ConsoleMessageTracer : IDispatchMessageInspector, IClientMessageInspector
	{
		public object AfterReceiveRequest(ref Message request, IClientChannel channel, InstanceContext instanceContext)
		{
			request = TraceMessage(request.CreateBufferedCopy(int.MaxValue));
			return null;
		}

		public void BeforeSendReply(ref Message reply, object correlationState)
		{
			reply = TraceMessage(reply.CreateBufferedCopy(int.MaxValue));
		}

		public void AfterReceiveReply(ref Message reply, object correlationState)
		{
			reply = TraceMessage(reply.CreateBufferedCopy(int.MaxValue));
		}

		public object BeforeSendRequest(ref Message request, IClientChannel channel)
		{
			request = TraceMessage(request.CreateBufferedCopy(int.MaxValue));
			return null;
		}

		Message TraceMessage(MessageBuffer buffer)
		{
			Message message = buffer.CreateMessage();
			Console.WriteLine("\n{0}\n", message);
			return buffer.CreateMessage();
		}
	}
}
